<template>
  <div id="app" class="main-layout">
    <header class="header" :style="{ backgroundColor: headerColor }">
      <div class="header-logo">
        <router-link to="/">
          <img
            src="@/assets/img/murr_logo_and_name.png"
            @mouseover="changeHeaderColor"
            alt=""
          />
        </router-link>
      </div>
      <div class="header-profile">
        <template v-if="currentMurren">
          <router-link :to="urlToMurren">
            <span
              v-if="profileData.showNotify"
              class="header-profile-notify"
            ></span>

            <img :src="currentMurren.avatar" alt=""
                 onerror="this.src='http://murrengan.ru/murr-back/media/profile/default_murren_avatar.png'"
            />
          </router-link>
        </template>
        <template v-else>
          <el-button class="murr-button__success" @click="showLoginForm"
            >Войти</el-button
          >
        </template>
      </div>
    </header>
    <main class="main-layout-content">
      <router-view />
    </main>
    <transition name="slide-fade-y" mode="out-in">
      <SignUp v-if="this.$store.getters.showRegisterForm_getters" />
      <Login v-if="this.$store.getters.showLoginForm_getters" />
      <ResetPassword v-if="this.$store.getters.showResetPasswordForm_getters" />
    </transition>
    <modal />
    <NotificationPopups v-if="currentMurren" />
  </div>
</template>

<script>
import { mapActions, mapGetters } from "vuex";
import SignUp from "./components/murren/SignUp";
import Login from "./components/murren/Login";
import ResetPassword from "./components/murren/ResetPassword";
import Modal from "./components/modal/Modal.vue";
import NotificationPopups from "./components/notification/NotificationPopups.vue";
import "./assets/scss/app.scss";

export default {
  name: "App",

  data() {
    return {
      headerColor: "",
    };
  },

  computed: {
    ...mapGetters(["currentMurren", "profileData"]),

    urlToMurren() {
      return {
        name: "murren",
        params: { murren_name: this.currentMurren.username },
      };
    },
  },

  methods: {
    ...mapActions({
      showLoginForm: "changeShowLoginForm_actions",
    }),

    changeHeaderColor() {
      this.headerColor = `rgb(
        ${Math.floor(Math.random() * (220 - 50) + 50)},
        ${Math.floor(Math.random() * (220 - 50) + 50)},
        ${Math.floor(Math.random() * (220 - 50) + 50)})`;
    },
  },

  components: {
    SignUp,
    Login,
    ResetPassword,
    Modal,
    NotificationPopups,
  },
};
</script>
